/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: This software is part of version 7.2 of the 
 * Andrew User Interface System and is the 
 * property of IBM, Carnegie Mellon University, 
 * and the other copyright holders.  The source 
 * code of this version is for the sole use of 
 * members of the Andrew Consortium with 
 * memberships extending into calendar year 
 * 1994.  This source code is not to be distributed 
 * to non-members of the consortium nor beyond 
 * a fifty-mile radius from the membership address.  
 * Binary object code compiled or derived from 
 * these sources is not to be distributed to non-
 * members.  Members may have additional 
 * distribution rights granted by prior written 
 * permission of Carnegie Mellon University.
 * 
 * IBM, CARNEGIE MELLON UNIVERSITY, 
 * AND THE OTHER COPYRIGHT HOLDERS
 *  DISCLAIM ALL WARRANTIES WITH 
 * REGARD TO THIS SOFTWARE, INCLUDING 
 * ALL IMPLIED WARRANTIES OF MERCHANT-
 * ABILITY AND FITNESS. IN 
 * NO EVENT SHALL  IBM, CARNEGIE 
 * MELLON UNIVERSITY, OR ANY OTHER 
 * COPYRIGHT HOLDER BE LIABLE FOR 
 * ANY SPECIAL, INDIRECT OR CONSE-
 * QUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT 
 * OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *  $
*/

#ifndef NORCSID
#define NORCSID
static char rcsid[]="$Header: /usr/user/auis-7.2/ams/libs/ms/RCS/dfltdir.c,v 2.6 1992/12/15 21:18:15 rr2b R6tape $";
#endif

#include <ms.h>

FindDefaultDir(Root, Name)
char *Root, *Name;
{
    int NumGood, NumBad;
    struct MS_Directory *Dir;

    sprintf(Name, "%s/%s", Root, AMS_DEFAULTMAILDIR);
    mserrcode = ReadOrFindMSDir(Name, &Dir, MD_OK);
    if (mserrcode == 0) {
	return(0);
    }
    if (AMS_ERRNO == EMSBADDIRFORMAT) {
	NonfatalBizarreError("Your mail directory was corrupted and is being automatically reconstructed.  Please wait...");
	return(MS_ReconstructDirectory(Name, &NumGood, &NumBad, TRUE));
    }
    if (AMS_ERRNO != ENOENT) {
	return(mserrcode);
    }
    sprintf(Name, "%s/misc", Root);
    mserrcode = ReadOrFindMSDir(Name, &Dir, MD_OK);
    if (mserrcode == 0) {
	return(0);
    }
    if (AMS_ERRNO == EMSBADDIRFORMAT) {
	NonfatalBizarreError("Your misc directory was corrupted and is being automatically reconstructed.  Please wait...");
	return(MS_ReconstructDirectory(Name, &NumGood, &NumBad, TRUE));
    }
    if (AMS_ERRNO != ENOENT) {
	return(mserrcode);
    }
    /* Could try other things here eventually */
    return(mserrcode);
}
