/* COMMON #defines */

/*
	$Disclaimer: This software is part of version 7.2 of the 
 * Andrew User Interface System and is the 
 * property of IBM, Carnegie Mellon University, 
 * and the other copyright holders.  The source 
 * code of this version is for the sole use of 
 * members of the Andrew Consortium with 
 * memberships extending into calendar year 
 * 1994.  This source code is not to be distributed 
 * to non-members of the consortium nor beyond 
 * a fifty-mile radius from the membership address.  
 * Binary object code compiled or derived from 
 * these sources is not to be distributed to non-
 * members.  Members may have additional 
 * distribution rights granted by prior written 
 * permission of Carnegie Mellon University.
 * 
 * IBM, CARNEGIE MELLON UNIVERSITY, 
 * AND THE OTHER COPYRIGHT HOLDERS
 *  DISCLAIM ALL WARRANTIES WITH 
 * REGARD TO THIS SOFTWARE, INCLUDING 
 * ALL IMPLIED WARRANTIES OF MERCHANT-
 * ABILITY AND FITNESS. IN 
 * NO EVENT SHALL  IBM, CARNEGIE 
 * MELLON UNIVERSITY, OR ANY OTHER 
 * COPYRIGHT HOLDER BE LIABLE FOR 
 * ANY SPECIAL, INDIRECT OR CONSE-
 * QUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT 
 * OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *  $
*/


/* MIME-compliant format */
#define METAMAIL_ENV 1
#define MK_METAMAIL 1

/* Build WhitePages */
#ifndef WHITEPAGES_ENV
#define WHITEPAGES_ENV 1
#endif

/* Build malloc and turn on debugging */
#define ANDREW_MALLOC_ENV 1
#define DEBUG_MALLOC_ENV 1

/* Define sections of AUIS to build */

#ifndef MK_BASIC_UTILS
#define MK_BASIC_UTILS 1
#endif

#ifndef MK_AUTHORING
#define MK_AUTHORING 1
#endif

#ifndef MK_AUX_UTILS
#define MK_AUX_UTILS 1
#endif

#ifndef MK_AUX_INSETS
#define MK_AUX_INSETS 1
#endif

#define MK_ZIP 1
#define MK_CALC 1
#define MK_CHAMP 1

/* what does this do */
#define ANDREW_PRINTING_ENV 1

/* CMU-specific instructions. */
#ifndef CMU_ENV
#define	CMU_ENV	1
#endif

/* Linkinstall variable used in iwash  --- temporary until iwash is done
#ifndef HOWINSTALL_ENV
#define HOWINSTALL_ENV 1
#endif

#if ( HOWINSTALL_ENV == 1 )
#ifndef LINKINSTALL_ENV
#define LINKINSTALL_ENV 1
#endif
#else
#undef LINKINSTALL_ENV
#endif
*/

#ifdef LINKINSTALL_ENV
#undef LINKINSTALL_ENV
#endif

/* Build contributions here at CMU. */
#define CONTRIB_ENV 1
#define SCRIBETEXT_ENV 1
#define RTF_ENV 1

/*  For X11R4 and later servers */
#define	ISO80_FONTS_ENV	1

/* System Specific #defines */

/* Build the site directory */
#ifdef SITE_ENV
#undef SITE_ENV 
#endif

/* Build against AFS libraries */
#define	AFS_ENV	1
#define	AFS30_ENV 1
#define AFS31_ENV 1

#ifdef AFS_ULTRIX_40
#undef AFS_ULTRIX_40
#endif 

/* Build the delivery system for mach machines */
#ifndef AMS_DELIVERY_ENV
#define AMS_DELIVERY_ENV 1
#endif

#ifndef RUN_AMDS_ENV
#define RUN_AMDS_ENV 1
#endif 

/* Use ./inst/install */
#ifndef BUILDANDREWINSTALL_ENV
#define BUILDANDREWINSTALL_ENV 1
#endif

/* Do not use bdffonts */
#ifdef FONTS_TO_BDF_ENV
#undef FONTS_TO_BDF_ENV
#endif 

/* Set destination directory */
#ifdef DEFAULT_ANDREWDIR_ENV
#undef DEFAULT_ANDREWDIR_ENV 
#define DEFAULT_ANDREWDIR_ENV /usr/misc/.atk
#endif

#define print_PRINTCOMMAND "psdit|lpr"
#define print_PSCPRINTCOMMAND "lpr"
