/* Copyright 1992 Carnegie Mellon University All rights reserved.
  $Disclaimer: This software is part of version 7.2 of the 
 * Andrew User Interface System and is the 
 * property of IBM, Carnegie Mellon University, 
 * and the other copyright holders.  The source 
 * code of this version is for the sole use of 
 * members of the Andrew Consortium with 
 * memberships extending into calendar year 
 * 1994.  This source code is not to be distributed 
 * to non-members of the consortium nor beyond 
 * a fifty-mile radius from the membership address.  
 * Binary object code compiled or derived from 
 * these sources is not to be distributed to non-
 * members.  Members may have additional 
 * distribution rights granted by prior written 
 * permission of Carnegie Mellon University.
 * 
 * IBM, CARNEGIE MELLON UNIVERSITY, 
 * AND THE OTHER COPYRIGHT HOLDERS
 *  DISCLAIM ALL WARRANTIES WITH 
 * REGARD TO THIS SOFTWARE, INCLUDING 
 * ALL IMPLIED WARRANTIES OF MERCHANT-
 * ABILITY AND FITNESS. IN 
 * NO EVENT SHALL  IBM, CARNEGIE 
 * MELLON UNIVERSITY, OR ANY OTHER 
 * COPYRIGHT HOLDER BE LIABLE FOR 
 * ANY SPECIAL, INDIRECT OR CONSE-
 * QUENTIAL DAMAGES OR ANY DAMAGES 
 * WHATSOEVER RESULTING FROM LOSS OF
 * USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT 
 * OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *  $
 */

#include <andrewos.h>
#include <util.h>

char pathopen_realpath[MAXPATHLEN+1];
FILE *pathopen(char  *path, char  *fpath, char  *mode)
{
    char *p=path;
    FILE *fp=NULL;
    while (*p && fp==NULL) {
	int len;
	char *q=strchr(p, ':');
	if(q==NULL) len=strlen(p);
	else len = q-p;
	if(len+strlen(fpath)+2<MAXPATHLEN) {
	    strncpy(pathopen_realpath, p, len);
	    strcpy(pathopen_realpath+len, "/");
	    strcat(pathopen_realpath+len, fpath);
	    fp=fopen(pathopen_realpath, mode);
	}
	p+=len;
	if(*p) p++;
    }
    if(fp==NULL) {
	return NULL;
    }
    return fp;
}
